package com.thesis.backend.entity;

import java.io.File;

/**
 * 
 * Paper class, for representing the academic papers. Contains mostly getters and setters
 *
 */
public class Paper {

	private File paper;
	private boolean labeled;
	private String Id;

	private String raw_text;
	private String approach;
	private String title;

	private String year;
	private String method;
	private String country;
	private String publisher;
	private String cite_typ;

	// Store path to CRF mallet input file
	private String crf_ML_input;
	// Store path to Classifier/Topic Modeler mallet input file
	private String cl_ML_input;

	public Paper(String raw_text, boolean labeled, String Id) {
		this.raw_text = raw_text;
		this.labeled = labeled;
		this.Id = Id;
	}

	public String getApproach() {
		return approach;
	}

	public void setApproach(String approach) {
		this.approach = approach;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getYear() {
		return year;
	}

	public void setYear(String year) {
		this.year = year;
	}

	public String getMethod() {
		return method;
	}

	public void setMethod(String method) {
		this.method = method;
	}

	public String getCountry() {
		return country;
	}

	public void setCountry(String country) {
		this.country = country;
	}

	public String getPublisher() {
		return publisher;
	}

	public void setPublisher(String publisher) {
		this.publisher = publisher;
	}

	public String getCite_typ() {
		return cite_typ;
	}

	public void setCite_typ(String cite_typ) {
		this.cite_typ = cite_typ;
	}

	public boolean isLabeled() {
		return labeled;
	}

	public String getId() {
		return Id;
	}

	public String getRaw_text() {
		return raw_text;
	}

	public void setRaw_text(String raw_text) {
		this.raw_text = raw_text;
	}

	public String getCrf_ML_input() {
		return crf_ML_input;
	}

	public void setCrf_ML_input(String crf_ML_input) {
		this.crf_ML_input = crf_ML_input;
	}

	public String getCl_ML_input() {
		return cl_ML_input;
	}

	public void setCl_ML_input(String cl_ML_input) {
		this.cl_ML_input = cl_ML_input;
	}

	public String toString() {
		return "ID: " + getId() + " TITLE: " + getTitle() + "\t"
				+ " APPROACH: " + getApproach() + "\t" + " METHOD: "
				+ getMethod() + "\t" + " COUNTRY: " + getCountry() + "\t"
				+ " PUBLISHER: " + getPublisher() + "\t"
				+ " PUBLICATION TYPE: " + getCite_typ() + "\t" + " YEAR: "
				+ getYear() + "\t";
	}

}
