package com.thesis.backend.util;

import cc.mallet.pipe.Pipe;
import cc.mallet.types.Instance;
import cc.mallet.types.Token;
import cc.mallet.types.TokenSequence;

/**
 *
 * Average title length feature. Created by extending the pipe system of MALLET API
 */
public class AvgTitlePipe extends Pipe {

	private static final long serialVersionUID = -2666952380908134512L;

	int avgTitleLength;
	String featureName;

	/**
	 * @param featureName
	 * @param avgTitleLength
	 */
	public AvgTitlePipe(String featureName, int avgTitleLength) {
		this.avgTitleLength = avgTitleLength;
		this.featureName = featureName;
	}

	public Instance pipe(Instance instance) {

		TokenSequence sequence = (TokenSequence) instance.getData();
		for (int i = 0; i < avgTitleLength; i++) {
			Token token = sequence.get(i);
			token.setFeatureValue(featureName, 1.0);

		}
		return instance;
	}

}
