package com.thesis.backend.util;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.nio.charset.Charset;

/**
 * 
 * Class which takes care of IOOperations
 */
public class IOOperations {

	/**
	 * Write temp text file into directory
	 * @param saveFilePath
	 * @param output
	 */
	public void writeToTxtFile(String saveFilePath, String output) {
		try {
			System.out.println(saveFilePath);
			BufferedWriter out = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(saveFilePath),
					Charset.forName("UTF-8")));
			out.write(output);
			out.close();
		} catch (IOException e) {
			System.out
					.println("Exception in writeToTxtFile in saveToFile.java");
			System.out.println(e.getMessage());
		}
	}

	/**
	 * Read through file
	 * @param filePath
	 * @return fileText
	 * @throws IOException
	 */
	public static String readFromFile(String filePath) throws IOException {
		String fileText = "";
		BufferedReader in = new BufferedReader(new FileReader(filePath));
		String line = in.readLine();
		while (line != null) {
			line = in.readLine();
			fileText += line;
		}
		return fileText;
	}

	/**
	 * Filter so that just .txt files are read
	 * @param dirName
	 * @return list of txt files
	 */
	public File[] finder(String dirName) {
		File dir = new File(dirName);

		return dir.listFiles(new FilenameFilter() {
			public boolean accept(File dir, String filename) {
				return filename.endsWith(".txt");
			}
		});

	}
	/**
	 * Create directory for uploaded file
	 * @param sessionName
	 * @return boolean telling directory is successfully created
	 */
	public boolean createDir(String sessionName) {
		File dir = new File("bin/Article_Sys/Sessions/" + sessionName);
		File dir2 = new File("bin/Article_Sys/Sessions/" + sessionName
				+ "/ML_Input");
		return dir.mkdir() && dir2.mkdir();
	}

}
