package com.thesis.backend.util;

import java.io.IOException;

import com.thesis.backend.entity.Paper;


/**
 * Creates the .txt files which show the MALLET input (mostly for debugging purposes) and the
 * InstanceLists that the models use
 *
 */
public class PreProcessor {
	IOOperations ioOp = new IOOperations();

	/**
	 * Parse and save text to MALLET input formats
	 * @param paper
	 * @throws IOException
	 */
	public void parseToMalletFormats(Paper paper) throws IOException {
		System.out.println("ParseMallet called");
		String crfF = "";
		String docTPF = "";
		crfF = crfFormat(paper.getRaw_text());
		docTPF = classifierFormat(paper.getRaw_text(), paper.getId());
		String crfMalletPath = "bin/Article_Sys/Sessions/" + paper.getId()
				+ "/ML_Input/CRF_ML.txt";
		String docMalletPath = "bin/Article_Sys/Sessions/" + paper.getId()
				+ "/ML_Input/DOC_ML.txt";
		ioOp.createDir(paper.getId());
		ioOp.writeToTxtFile(crfMalletPath, crfF);
		ioOp.writeToTxtFile(docMalletPath, docTPF);
		paper.setCl_ML_input(docMalletPath);
		paper.setCrf_ML_input(crfMalletPath);
		// }
		// else throw new
		// IOException("Something went wrong when creating the directory structure"
		// +
		// "- see PreProcessor.java and createDir.java");
	}

	/**
	 * CRF input format OBS: label is set automatically to X here
	 * @param txt
	 * @return
	 */
	private String crfFormat(String txt) {
		String output = "";
		String[] splitString = txt.split("\\s+");
		for (int i = 0; i < splitString.length - 1; i++) {
			output += splitString[i] + "\n";
		}
		return output;
	}

	/**
	 * Classifier and Topic model format. X added as default label
	 * @param txt
	 * @param id
	 * @return 
	 */
	private String classifierFormat(String txt, String id) {
		return id + " " + "X" + " " + txt + "\n";
	}

}
