package com.thesis.frondend.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.DockLayoutPanel;
import com.google.gwt.user.client.ui.RootPanel;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 * main class for the frondend
 */
public class ERA implements EntryPoint {
	// RPC communication between client and server
	private final BackendServiceAsync backendService = GWT
			.create(BackendService.class);

	RootPanel rootPanel = RootPanel.get();

	private FileUploadPanel uploadPanel;
	private PaperForm paperForm;
	private ListPanel listPanel;

	public void onModuleLoad() {
		DockLayoutPanel mainPanel = new DockLayoutPanel(Unit.EM);
		mainPanel.setStyleName("body");
		uploadPanel = new FileUploadPanel(this);
		uploadPanel.setStyleName("Upload");
		paperForm = new PaperForm();
		listPanel = new ListPanel(this);

		mainPanel.addNorth(uploadPanel, 4.0);
		mainPanel.addWest(listPanel, 7.7);
		listPanel.setHorizontalScrollPosition(1);
		mainPanel.add(paperForm);
		paperForm.setSize("717", "443");

		rootPanel.add(mainPanel, 5, 5);
		mainPanel.setSize("717px", "495px");

	}

	/**
	 * Start call, which sends filepath to backend via BackendService
	 * @param filePath
	 */
	public void sendFile(String filePath) {
		backendService.sendToBackEnd(filePath, new AsyncCallback<Item>() {

			@Override
			public void onSuccess(Item result) {
				listPanel.addItem(result);
			}

			@Override
			public void onFailure(Throwable caught) {
				Window.alert("RPC sendFile() to backEnd failed");
				Window.alert(caught.getMessage());
			}
		});
	}

	/**
	 * Set new selected item
	 * @param item
	 */
	public void setSelectedItem(Item item) {
		paperForm.setItem(item);
	}
}
