package com.thesis.frondend.client;

import java.util.List;

import com.google.gwt.cell.client.AbstractCell;
import com.google.gwt.safehtml.shared.SafeHtmlBuilder;
import com.google.gwt.user.cellview.client.CellList;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.ScrollPanel;
import com.google.gwt.view.client.ListDataProvider;
import com.google.gwt.view.client.SelectionChangeEvent;
import com.google.gwt.view.client.SingleSelectionModel;

/**
 * Creating the list panel
 *
 */
public class ListPanel extends ScrollPanel {

	private CellList<Item> cellList;
	private ListDataProvider<Item> dataProvider = new ListDataProvider<Item>();
	final SingleSelectionModel<Item> selectionModel = new SingleSelectionModel<Item>();
	private ERA entryPoint;

	public ListPanel(ERA entryPoint) {
		setEntryPoint(entryPoint);
		addStyleName("listPanel");
		cellList = new CellList<Item>(new AbstractCell<Item>() {
			@Override
			public void render(Context context, Item value, SafeHtmlBuilder sb) {
				sb.appendHtmlConstant("<div class='paperItem'>");
				sb.appendHtmlConstant("Paper");
				sb.appendHtmlConstant("</div>");
			}
		});
		// Add a selection model so we can select cells.
		cellList.setSelectionModel(selectionModel);
		selectionModel
				.addSelectionChangeHandler(new SelectionChangeEvent.Handler() {
					public void onSelectionChange(SelectionChangeEvent event) {
						getEntryPoint().setSelectedItem(
								selectionModel.getSelectedObject());
					}
				});
		dataProvider.addDataDisplay(cellList);
		add(cellList);
	}

	public void setEntryPoint(ERA entryPoint) {
		this.entryPoint = entryPoint;
	}

	public ERA getEntryPoint() {
		return entryPoint;
	}

	public void addItem(Item item) {
		List<Item> items = dataProvider.getList();
		items.remove(item);
		items.add(item);
		cellList.setRowCount(items.size());
		cellList.setRowData(0, items);
		selectionModel.setSelected(item, true);
		cellList.redraw();
		dataProvider.refresh();
	}

}
