package com.thesis.frondend.client;

import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.Grid;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.SimplePanel;
import com.google.gwt.user.client.ui.TextBox;

/**
 * Class to specifically set the item values in the frondend. 
 */
public class PaperForm extends SimplePanel {

	private TextBox title;
	private Label titleName;
	private TextBox approach;
	private Label approachName;
	private TextBox method;
	private Label methodName;
	private TextBox year;
	private Label yearName;
	private TextBox country;
	private Label countryName;
	private TextBox publisher;
	private Label publisherName;
	private TextBox cite_typ;
	private Label cite_typName;

	private Item item;

	public PaperForm() {
		setItem(null);
		addStyleName("paperForm");
		Grid grid = new Grid(7, 2);
		title = new TextBox();
		title.setReadOnly(true);
		titleName = new Label("TITLE");

		approach = new TextBox();
		approach.setReadOnly(true);
		approachName = new Label("APPROACH");

		method = new TextBox();
		method.setReadOnly(true);
		methodName = new Label("METHOD");

		year = new TextBox();
		year.setReadOnly(true);
		yearName = new Label("YEAR");

		country = new TextBox();
		country.setReadOnly(true);
		countryName = new Label("COUNTRY");

		publisher = new TextBox();
		publisher.setReadOnly(true);
		publisherName = new Label("PUBLISHER");

		cite_typ = new TextBox();
		cite_typ.setReadOnly(true);
		cite_typName = new Label("PUBLICATION TYPE");

		grid.setWidget(0, 0, titleName);
		grid.setWidget(0, 1, title);
		grid.setWidget(1, 0, methodName);
		grid.setWidget(1, 1, method);
		grid.setWidget(2, 0, approachName);
		grid.setWidget(2, 1, approach);
		grid.setWidget(3, 0, yearName);
		grid.setWidget(3, 1, year);
		grid.setWidget(4, 0, countryName);
		grid.setWidget(4, 1, country);
		grid.setWidget(5, 0, publisherName);
		grid.setWidget(5, 1, publisher);
		grid.setWidget(6, 0, cite_typName);
		grid.setWidget(6, 1, cite_typ);

		add(grid);
	}

	public void setItem(Item item) {
		this.item = item;
		if (item != null) {
			title.setText(item.getTitle());
			approach.setText(item.getApproach());
			method.setText(item.getMethod());
			year.setValue(item.getYear());
			country.setValue(item.getCountry());
			publisher.setValue(item.getPublisher());
			cite_typ.setValue(item.getCite_typ());
		}
	}

}
