package com.thesis.frondend.server;

import java.io.IOException;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;
import com.thesis.backend.entity.Paper;
import com.thesis.backend.main.Main;
import com.thesis.frondend.client.BackendService;
import com.thesis.frondend.client.Item;

/**
 * BackendServiceImpl
 */
public class BackendServiceImpl extends RemoteServiceServlet implements
		BackendService {

	private static final long serialVersionUID = -5332165871392162549L;
	// Initialize backend
	private Main main = new Main();

	@Override
	//
	public Item sendToBackEnd(String filePath) throws IOException {
		System.out.println("RECEIVED FILEPATH " + filePath);
		// Sending paper through classifiers
		Paper paper = main.startPaperJourney(FileList.getFile());

		// Creating result item
		Item result = new Item();
		System.out.println("RESULT ITEM CREATED");
		// Setting value of result item
		if (paper.getApproach().isEmpty())
			result.setApproach("N/A");
		else
			result.setApproach(paper.getApproach());

		if (paper.getTitle().isEmpty())
			result.setTitle("N/A");
		else
			result.setTitle(paper.getTitle());

		if (paper.getCite_typ().isEmpty())
			result.setCite_typ("N/A");
		else
			result.setCite_typ(paper.getCite_typ());

		if (paper.getCountry().isEmpty())
			result.setCountry("N/A");
		else
			result.setCountry(paper.getCountry());

		if (paper.getMethod().isEmpty())
			result.setMethod("N/A");
		else
			result.setMethod(paper.getMethod());

		if (paper.getPublisher().isEmpty())
			result.setPublisher("N/A");
		else
			result.setPublisher(paper.getPublisher());

		if (paper.getYear().isEmpty())
			result.setYear("N/A");
		else
			result.setYear(paper.getYear());

		return result;
	}

}
