package com.thesis.frondend.server;

import gwtupload.server.UploadAction;
import gwtupload.server.exceptions.UploadActionException;

import java.io.File;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.fileupload.FileItem;

/**
 * FileUploadServlet that handles when file is uploaded
 */
public class FileUploadServlet extends UploadAction {
	// extends UploadAction
	private static final long serialVersionUID = -8739847620747308685L;

	/**
	 * Override executeAction
	 */
	public String executeAction(HttpServletRequest request,
			List<FileItem> sessionFiles) throws UploadActionException {
		String msg = "";
		for (FileItem item : sessionFiles) {
			if (!item.isFormField()) {
				try {
					// / Create a temp file
					File file = File.createTempFile("tempFile-", ".txt");
					item.write(file);

					msg += "File saved as " + file.getAbsolutePath();
					System.out.println(msg);

					// File added to static filelist
					FileList.addFile(file);

				} catch (Exception e) {
					throw new UploadActionException(e);
				}
			}
		}
		// / Remove files from session
		removeSessionFileItems(request);

		// / Send customized message to client.
		return msg;
	}

}
